
#define _LARGEFILE_SOURCE 
#define _LARGEFILE64_SOURCE

#include <stdio.h>
#include <stdint.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>

#define BUF_SIZE 1<<15

uint64_t count[256];

int main(int argc, char *argv[]) {
  unsigned char buf[BUF_SIZE];
  int fd;
  unsigned int i;
  int n;

  if(argc <= 1 || (argc == 2 && strcmp(argv[1], "-") == 0 ) )
    fd = 0;
  else {
    fd = open(argv[1], O_RDONLY | O_LARGEFILE);
    if(fd == -1) {
      perror("open");
      return 1;
    }
  }

  while( (n = read(fd, buf, sizeof(buf))) > 0 ) {
    for(i = 0; i < (unsigned int)n; i++)
      count[buf[i]]++;
  }

  if(n == -1) {
    perror("read");
    return 2;
  }

  close(fd);
  
  for(i = 0; i < sizeof(count)/sizeof(*count); i++)
    printf("%d %llu\n", i, count[i]);

  return 0;  
}
